//---------------------------------------------------------------------------
// http://radiohlam.ru
#ifndef Unit1H
#define Unit1H
#define BUFSIZE 1024
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <jpeg.hpp>
#include <math.h>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
  DCB    dcb;                   //  DCB
  HANDLE Port;                  //  
  OVERLAPPED ovr_wr, ovr_rd;
  AnsiString FilePath;;

  unsigned char wr_buf[BUFSIZE], rd_buf[BUFSIZE]; //   
  int  wr_buf_len, rd_buf_len;
  bool BS_FLAG;

  struct chip { AnsiString Name; int Model, Size, ByteInWord;} SelectedChip;

bool WriteTo(void);
bool ReadFrom(void);
void OpenPort(void);
void ClosePort(void);
void BuidMemory(void);
void LoadHexFile(void);
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key);
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *ChipSelect1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TMenuItem *N93C061;
        TMenuItem *N93C461;
        TPanel *Panel1;
        TButton *Button1;
        TButton *Button2;
        TEdit *Edit1;
        TButton *Button3;
        TButton *Button4;
        TComboBox *ComboBox1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TRichEdit *RichEdit1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TRichEdit *RichEdit2;
        TRichEdit *RichEdit3;
        TMenuItem *NM93C131;
        TMenuItem *NM93C141;
        TImage *Image1;
        TMenuItem *N93C561;
        TMenuItem *N93C571;
        TMenuItem *N93C661;
        TMenuItem *N93C761;
        TMenuItem *N93C861;
        TMenuItem *N1;
        TMenuItem *N2;
        TMenuItem *AT59C111;
        TMenuItem *AT59C221;
        TMenuItem *AT59C131;
        TMenuItem *N3;
        TMenuItem *AK6420A1;
        TMenuItem *AK6440A1;
        TMenuItem *AK6480A1;
        TMemo *Memo1;
        TOpenDialog *OpenDialog1;
        TMenuItem *Open1;
        TSaveDialog *SaveDialog1;
        TPanel *Panel2;
        TStaticText *StaticText1;
        TMenuItem *Saveas1;
        TMenuItem *Save1;
        TMenuItem *N4;
        TMenuItem *N5;
        TMenuItem *AT250101;
        TMenuItem *AT250201;
        TMenuItem *AT250401;
        TMenuItem *N250801;
        TMenuItem *N2501;
        TMenuItem *N253201;
        TMenuItem *N256401;
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall N93C061Click(TObject *Sender);
        void __fastcall RichEdit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall RichEdit1KeyPress(TObject *Sender, char &Key);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall N93C461Click(TObject *Sender);
        void __fastcall NM93C131Click(TObject *Sender);
        void __fastcall NM93C141Click(TObject *Sender);
        void __fastcall N93C561Click(TObject *Sender);
        void __fastcall N93C571Click(TObject *Sender);
        void __fastcall N93C661Click(TObject *Sender);
        void __fastcall N93C761Click(TObject *Sender);
        void __fastcall N93C861Click(TObject *Sender);
        void __fastcall AT59C111Click(TObject *Sender);
        void __fastcall AT59C221Click(TObject *Sender);
        void __fastcall AT59C131Click(TObject *Sender);
        void __fastcall AK6420A1Click(TObject *Sender);
        void __fastcall AK6440A1Click(TObject *Sender);
        void __fastcall AK6480A1Click(TObject *Sender);
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall Saveas1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall AT250101Click(TObject *Sender);
        void __fastcall AT250201Click(TObject *Sender);
        void __fastcall AT250401Click(TObject *Sender);
        void __fastcall N250801Click(TObject *Sender);
        void __fastcall N2501Click(TObject *Sender);
        void __fastcall N253201Click(TObject *Sender);
        void __fastcall N256401Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
